#include "spamtac.h"
#include "game.h"
#include "spam.h"
#include "dirty.h"

#define MAX_SPAM 100

struct SPAM {
	int x;
	int y;
	bool alive;
} spams[MAX_SPAM];

void init_spam(void) {
	for (int i = 0; i < MAX_SPAM; i++) {
		spams[i].alive = false;
	}
}

void add_spam(void) {
	for (int i = 0; i < MAX_SPAM; i++) {
		if (!spams[i].alive) {
			spams[i].y = -spam->h;
			spams[i].x = rand()%(SCREEN_W-spam->w);
			spams[i].alive = true;
			break;
		}
	}
}

void process_spam(void) {
	for (int i = 0; i < MAX_SPAM; i++) {
		if (spams[i].alive) {
			spams[i].y += 2;
			if (spams[i].y > SCREEN_H) {
				spams[i].alive = false;
				hit_player();
			}
		}
	}
}

void draw_spam(BITMAP *bmp) {
	for (int i = 0; i < MAX_SPAM; i++) {
		if (spams[i].alive) {
			draw_sprite(bmp, spam, spams[i].x, spams[i].y);
			dirty_rectangle(spams[i].x, spams[i].y, spam->w, spam->h);
		}
	}
}

bool spam_collide(int x, int y) {
	int bx1 = x;
	int bx2 = x + banana->h;
	int by1 = y;
	int by2 = y + banana->w;
	int x1, x2, y1, y2;
	for (int i = 0; i < MAX_SPAM; i++) {
		if (spams[i].alive) {
			x1 = spams[i].x;
			x2 = x1 + spam->w;
			y1 = spams[i].y;
			y2 = y1 + spam->h;

			if (!(y2 < by1 || y1 > by2 || x2 < bx1 || x1 > bx2)) {
				spams[i].alive = false;
				return true;
			}
			// Get box collision code and use here
		}
	}
	return false;
}
